---
title: DeprecationReportBody
slug: Web/API/DeprecationReportBody
tags:
  - API
  - DeprecationReportBody
  - Experimental
  - Interface
  - Reference
  - Reporting API
---
<div>{{seecompattable}}{{APIRef("Reporting API")}}</div>

<p class="summary">The <code>DeprecationReportBody</code> interface of the <a href="/en-US/docs/Web/API/Reporting_API">Reporting API</a> represents the body of a deprecation report (the return value of its {{domxref("Report.body")}} property).</p>

<p class="summary">A deprecation report is generated when a deprecated feature (e.g. a deprecated API method) is used on a document being observed by a {{domxref("ReportingObserver")}}.</p>

<h2 id="Properties">Properties</h2>

<dl>
 <dt><code>id</code></dt>
 <dd>A string representing the deprecated feature that generated the report, for example <code>NavigatorGetUserMedia</code>. This can be used to group reports by deprecated feature.</dd>
 <dt><code>anticipatedRemoval</code></dt>
 <dd>A {{jsxref("Date")}} object (rendered as a string) representing the date when the feature is expected to be removed from the current browser. If the date is not known, this property will return <code>null</code>.</dd>
 <dt><code>message</code></dt>
 <dd>A string containing a human-readable description of the deprecation, including information such as what newer feature has superceded it, if any. This typically matches the message a browser will display in its DevTools console when a deprecated feature is used, if one is available.</dd>
 <dt><code>sourceFile</code></dt>
 <dd>A string containing the path to the source file where the deprecated feature was used, if known, or <code>null</code> otherwise.</dd>
 <dt><code>lineNumber</code></dt>
 <dd>A number representing the line in the source file in which the deprecated feature was used, if known, or <code>null</code> otherwise.</dd>
 <dt><code>columnNumber</code></dt>
 <dd>A number representing the column in the source file in which the deprecated feature was used, if known, or <code>null</code> otherwise.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>In our <a href="https://mdn.github.io/dom-examples/reporting-api/deprecation_report.html">deprecation_report.html</a> example, we create a simple reporting observer to observe usage of deprecated features on our web page:</p>

<pre class="brush: js">let options = {
  types: ['deprecation'],
  buffered: true
}

let observer = new ReportingObserver(function(reports, observer) {
  reportBtn.onclick = () =&gt; displayReports(reports);
}, options);</pre>

<p>We then tell it to start observing reports using {{domxref("ReportingObserver.observe()")}}; this tells the observer to start collecting reports in its report queue, and runs the callback function specified inside the constructor:</p>

<pre class="brush: js">observer.observe();</pre>

<p>Because of the event handler we set up inside the <code>ReportingObserver()</code> constructor, we can now click the button to display the report details.</p>

<p><img alt="image of a jolly bearded man with various stats displayed below it about a deprecated feature" src="https://mdn.mozillademos.org/files/16561/reporting_api_example.png" style="border-style: solid; border-width: 1px; display: block; height: 476px; margin: 0px auto; width: 902px;"></p>

<p>The report details are displayed via the <code>displayReports()</code> fuction, which takes the observer callback's <code>reports</code> parameter as its parameter:</p>

<pre class="brush: js">function displayReports(reports) {
  const outputElem = document.querySelector('.output');
  const list = document.createElement('ul');
  outputElem.appendChild(list);

  for(let i = 0; i &lt; reports.length; i++) {
    let listItem = document.createElement('li');
    let textNode = document.createTextNode('Report ' + (i + 1) + ', type: ' + reports[i].type);
    listItem.appendChild(textNode);
    let innerList = document.createElement('ul');
    listItem.appendChild(innerList);
    list.appendChild(listItem);

    for (let key in reports[i].body) {
      let innerListItem = document.createElement('li');
      let keyValue = reports[i].body[key];
      innerListItem.textContent = key + ': ' + keyValue;
      innerList.appendChild(innerListItem);
    }
  }
}</pre>

<p>The <code>reports</code> parameter contains an array of all the reports in the observer's report queue. We loop over each report using a basic <code><a href="/en-US/docs/Web/JavaScript/Reference/Statements/for">for</a></code> loop, then iterate over each entry of in the report's body (a <code>DeprecationReportBody</code> instance) using a <code><a href="/en-US/docs/Web/JavaScript/Reference/Statements/for...in">for...in</a></code> structure, displaying each key/value pair inside a list item.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("Reporting API","#deprecation-report","DeprecationReportBody")}}</td>
   <td>{{Spec2("Reporting API")}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.DeprecationReportBody")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Reporting_API">Reporting API</a></li>
</ul>
